summaryrefslogtreecommitdiffstats
path: root/ci/03-maasdeploy.sh
diff options
context:
space:
mode:
Diffstat (limited to 'ci/03-maasdeploy.sh')
-rwxr-xr-xci/03-maasdeploy.sh142
1 files changed, 97 insertions, 45 deletions
diff --git a/ci/03-maasdeploy.sh b/ci/03-maasdeploy.sh
index 479ab039..198d2484 100755
--- a/ci/03-maasdeploy.sh
+++ b/ci/03-maasdeploy.sh
@@ -2,6 +2,8 @@
#placeholder for deployment script.
set -ex
+source tools.sh
+
virtinstall=0
labname=$1
@@ -9,7 +11,19 @@ if [ ! -e $HOME/.ssh/id_rsa ]; then
ssh-keygen -N '' -f $HOME/.ssh/id_rsa
fi
-#install the packages needed
+NODE_ARCTYPE=`arch`
+NODE_ARC="amd64/generic"
+
+if [ "x86_64" == "$NODE_ARCTYPE" ]; then
+ NODE_ARC="amd64/generic"
+elif [ "ppc64le" == "$NODE_ARCTYPE" ]; then
+ NODE_ARC='ppc64el'
+else
+ NODE_ARC=$NODE_ARCTYPE
+fi
+
+# Install the packages needed
+echo_info "Installing and upgrading required packages"
sudo apt-get install software-properties-common -y
sudo apt-add-repository ppa:juju/stable -y
sudo apt-add-repository ppa:maas/stable -y
@@ -25,7 +39,7 @@ sudo apt-get install bridge-utils openssh-server bzr git virtinst qemu-kvm libvi
#sudo snap install maas --classic
#sudo snap install juju --classic
-sudo pip install --upgrade pip
+sudo -H pip install --upgrade pip
#first parameter should be custom and second should be either
# absolute location of file (including file name) or url of the
@@ -37,6 +51,7 @@ sudo pip install --upgrade pip
#
# Get labconfig and generate deployconfig.yaml
+echo_info "Parsing lab configuration file"
case "$labname" in
intelpod[569]|orangepod[12]|cengnpod[12] )
array=(${labname//pod/ })
@@ -81,8 +96,8 @@ python -c 'import sys, yaml, json; json.dump(yaml.load(sys.stdin), sys.stdout, i
MAAS_IP=$(grep " ip_address" deployconfig.yaml | cut -d ':' -f 2 | sed -e 's/ //')
MAAS_NAME=`grep "maas_name" deployconfig.yaml | cut -d ':' -f 2 | sed -e 's/ //'`
-API_SERVER="http://$MAAS_IP/MAAS/api/2.0"
-API_SERVERMAAS="http://$MAAS_IP/MAAS/"
+API_SERVER="http://$MAAS_IP:5240/MAAS/api/2.0"
+API_SERVERMAAS="http://$MAAS_IP:5240/MAAS/"
PROFILE=ubuntu
MY_UPSTREAM_DNS=`grep "upstream_dns" deployconfig.yaml | cut -d ':' -f 2 | sed -e 's/ //'`
SSH_KEY=`cat ~/.ssh/id_rsa.pub`
@@ -126,7 +141,7 @@ else
sudo mv 90-joid-init /etc/sudoers.d/
fi
-echo "... Deployment of maas Started ...."
+echo_info "Deployment of MAAS started"
#
# Virsh preparation
@@ -160,7 +175,7 @@ fi
# To avoid problem between apiclient/maas_client and apiclient from google
# we remove the package google-api-python-client from yardstick installer
-if [ $(pip list |grep google-api-python-client |wc -l) == 1 ]; then
+if [ $(pip list --format=columns | grep google-api-python-client | wc -l) == 1 ]; then
sudo pip uninstall google-api-python-client
fi
@@ -196,7 +211,7 @@ installmaas(){
#
configuremaas(){
#reconfigure maas with correct MAAS address.
- #Below code is needed as MAAS have issue in commisoning without restart.
+ #Below code is needed as MAAS have issue in commissioning without restart.
#sudo ./maas-reconfigure-region.sh $MAAS_IP
sleep 30
sudo maas-rack config --region-url http://$MAAS_IP:5240/MAAS
@@ -221,7 +236,7 @@ configuremaas(){
compute-external storage-data storage-cluster admin \
tenant-data tenant-api tenant-public
do
- echo "Creating the space $space"
+ echo_info "Creating the space $space"
maas $PROFILE spaces create name=$space || true
done
@@ -299,7 +314,7 @@ setupspacenetwork(){
'storage') JUJU_SPACE="tenant-stor"; DHCP='' ;;
'storagecluster') JUJU_SPACE="storclus"; DHCP='' ;;
'floating') JUJU_SPACE="tenant-public"; DHCP='' ;;
- *) JUJU_SPACE='default'; DHCP='OFF'; echo " >>> Unknown SPACE" ;;
+ *) JUJU_SPACE='default'; DHCP='OFF'; echo_info " >>> Unknown SPACE" ;;
esac
JUJU_SPACE_ID=$(maas $PROFILE spaces read | jq -r ".[] | select(.name==\"$JUJU_SPACE\")".id)
JUJU_VLAN_VID=$(maas $PROFILE subnets read | jq -r ".[] | select(.name==\"$SPACE_CIDR\")".vlan.vid)
@@ -310,7 +325,7 @@ setupspacenetwork(){
fi
fi
if ([ $type == "admin" ]); then
- # If we have a network, we create it
+ # If we have a network, we create it
if ([ $NET_FABRIC_ID ]); then
# Set ranges
SUBNET_PREFIX=${SPACE_CIDR::-5}
@@ -345,10 +360,12 @@ addnodes(){
# if we have a virshurl configuration we use it, else we use local
VIRSHURL=$(cat labconfig.json | jq -r '.opnfv.virshurl')
if ([ $VIRSHURL == "" ] || [ "$VIRSHURL" == "null" ]); then
- VIRSHURL="qemu+ssh://$USER@$MAAS_IP/system "
+ VIRSHIP=$MAAS_IP
+ VIRSHURL="qemu+ssh://$USER@$VIRSHIP/system "
VIRSHHOST=""
else
VIRSHHOST=$(echo $VIRSHURL| cut -d\/ -f 3 | cut -d@ -f2)
+ VIRSHIP="" # TODO: parse from $VIRSHURL if needed
fi
if [ "$virtinstall" -eq 1 ]; then
@@ -360,22 +377,34 @@ addnodes(){
# prepare a file containing virsh remote url to connect without adding it n command line
echo "export VIRSH_DEFAULT_CONNECT_URI=$VIRSHURL" > virsh_uri.sh
else
+ netw=""
+
brid=`brctl show | grep 8000 | cut -d "8" -f 1 | tr "\n" " " | tr " " " " | tr -s " "`
+ ADMIN_BR=`cat labconfig.json | jq '.opnfv.spaces[] | select(.type=="admin")'.bridge | cut -d \" -f 2 `
- netw=""
for feature in $brid; do
- if [ "$feature" == "" ]; then
- netw=$netw
- elif [ "$feature" == "virbr0" ]; then
- netw=$netw
- else
+ if [ "$feature" == "$ADMIN_BR" ]; then
netw=$netw" --network bridge="$feature",model=virtio"
+ else
+ netw=$netw
fi
done
fi
+ # Add server fingerprint to known hosts to prevent security prompt in the
+ # SSH connection during the virt-install
+ if [ $VIRSHIP != "" ]; then
+ # Check if the IP is not already present among the known hosts
+ if ! ssh-keygen -F $VIRSHIP > /dev/null ; then
+ echo_info "SSH fingerprint of the host is not known yet, adding to known_hosts"
+ ssh-keyscan -H $VIRSHIP >> ~/.ssh/known_hosts
+ fi
+ fi
+
+ echo_info "Creating and adding bootstrap node"
+
virt-install --connect $VIRSHURL --name bootstrap --ram 4098 --cpu host --vcpus 2 --video \
- cirrus --arch x86_64 --disk size=20,format=qcow2,bus=virtio,cache=directsync,io=native,pool=default \
+ cirrus --disk size=20,format=qcow2,bus=virtio,cache=directsync,io=native,pool=default \
$netw --boot network,hd,menu=off --noautoconsole \
--vnc --print-xml | tee bootstrap
@@ -396,7 +425,7 @@ addnodes(){
maas $PROFILE machines create autodetect_nodegroup='yes' name='bootstrap' \
tags='bootstrap' hostname='bootstrap' power_type='virsh' mac_addresses=$bootstrapmac \
power_parameters_power_address="$VIRSHURL" \
- architecture='amd64/generic' power_parameters_power_id='bootstrap'
+ architecture=$NODE_ARC power_parameters_power_id='bootstrap'
bootstrapid=$(maas $PROFILE machines read | jq -r '.[] | select(.hostname == "bootstrap").system_id')
@@ -419,36 +448,58 @@ addnodes(){
maas $PROFILE machines create autodetect_nodegroup='yes' name=$NODE_NAME \
tags='control compute' hostname=$NODE_NAME power_type='virsh' mac_addresses=$nodemac \
power_parameters_power_address="$VIRSHURL" \
- architecture='amd64/generic' power_parameters_power_id=$NODE_NAME
+ architecture=$NODE_ARC power_parameters_power_id=$NODE_NAME
nodeid=$(maas $PROFILE machines read | jq -r '.[] | select(.hostname == '\"$NODE_NAME\"').system_id')
maas $PROFILE tag update-nodes control add=$nodeid || true
maas $PROFILE tag update-nodes compute add=$nodeid || true
done
else
- units=`cat deployconfig.json | jq .opnfv.units`
+ units=`cat deployconfig.json | jq .opnfv.units`
- until [ $(($units)) -lt 1 ]; do
- units=$(($units - 1));
- NODE_NAME=`cat labconfig.json | jq ".lab.racks[].nodes[$units].name" | cut -d \" -f 2 `
- MAC_ADDRESS=`cat labconfig.json | jq ".lab.racks[].nodes[$units].nics[] | select(.spaces[]==\"admin\").mac"[0] | cut -d \" -f 2 `
- POWER_TYPE=`cat labconfig.json | jq ".lab.racks[].nodes[$units].power.type" | cut -d \" -f 2 `
- POWER_IP=`cat labconfig.json | jq ".lab.racks[].nodes[$units].power.address" | cut -d \" -f 2 `
- POWER_USER=`cat labconfig.json | jq ".lab.racks[].nodes[$units].power.user" | cut -d \" -f 2 `
- POWER_PASS=`cat labconfig.json | jq ".lab.racks[].nodes[$units].power.pass" | cut -d \" -f 2 `
-
- maas $PROFILE machines create autodetect_nodegroup='yes' name=$NODE_NAME \
- hostname=$NODE_NAME power_type=$POWER_TYPE power_parameters_power_address=$POWER_IP \
- power_parameters_power_user=$POWER_USER power_parameters_power_pass=$POWER_PASS mac_addresses=$MAC_ADDRESS \
- architecture='amd64/generic'
- done
+ until [ $(($units)) -lt 1 ]; do
+ units=$(($units - 1));
+ NODE_NAME=`cat labconfig.json | jq ".lab.racks[].nodes[$units].name" | cut -d \" -f 2 `
+ MAC_ADDRESS=`cat labconfig.json | jq ".lab.racks[].nodes[$units].nics[] | select(.spaces[]==\"admin\").mac"[0] | cut -d \" -f 2 `
+ #MAC_ADDRESS1=`cat labconfig.json | jq ".lab.racks[].nodes[$units].nics[] | select(.spaces[]==\"floating\").mac"[0] | cut -d \" -f 2 `
+ POWER_TYPE=`cat labconfig.json | jq ".lab.racks[].nodes[$units].power.type" | cut -d \" -f 2 `
+ POWER_IP=`cat labconfig.json | jq ".lab.racks[].nodes[$units].power.address" | cut -d \" -f 2 `
+ POWER_USER=`cat labconfig.json | jq ".lab.racks[].nodes[$units].power.user" | cut -d \" -f 2 `
+ POWER_PASS=`cat labconfig.json | jq ".lab.racks[].nodes[$units].power.pass" | cut -d \" -f 2 `
+ NODE_ARCTYPE=`cat labconfig.json | jq ".lab.racks[].nodes[$units].architecture" | cut -d \" -f 2 `
+
+ if [ "x86_64" == "$NODE_ARCTYPE" ]; then
+ NODE_ARC="amd64/generic"
+ elif [ "ppc64le" == "$NODE_ARCTYPE" ]; then
+ NODE_ARC='ppc64el'
+ else
+ NODE_ARC=$NODE_ARCTYPE
+ fi
+
+ echo_info "Creating node $NODE_NAME"
+ maas $PROFILE machines create autodetect_nodegroup='yes' name=$NODE_NAME \
+ hostname=$NODE_NAME power_type=$POWER_TYPE power_parameters_power_address=$POWER_IP \
+ power_parameters_power_user=$POWER_USER power_parameters_power_pass=$POWER_PASS mac_addresses=$MAC_ADDRESS \
+ architecture=$NODE_ARC
+ done
fi
maas $PROFILE pods create type=virsh power_address="$VIRSHURL" power_user=$USER
- # make sure nodes are added into MAAS and none of them is in commisoning state
- while [ "$(maas $PROFILE nodes read | grep Commissioning )" ];
+ # Make sure nodes are added into MAAS and none of them is in commissioning state
+ i=0
+ while [ "$(maas $PROFILE nodes read | grep Commissioning )" ];
do
+ echo_info "Waiting for nodes to finish commissioning. ${i} minutes elapsed."
sleep 60
+ i=$[$i+1]
+
+ # Make sure that no nodes have failed commissioning or testing
+ if [ "$(maas $PROFILE nodes read | grep 'Failed' )" ];
+ then
+ echo "Error: Some nodes have failed commissioning or testing" 1>&2
+ exit 1
+ fi
+
done
}
@@ -467,10 +518,10 @@ setupspacenetwork
sudo ./maas-reconfigure-region.sh $MAAS_IP
sleep 120
-#lets add the nodes now. Currently works only for virtual deploymnet.
+# Let's add the nodes now. Currently works only for virtual deployment.
addnodes
-echo "... Deployment of maas finish ...."
+echo_info "Initial deployment of MAAS finished"
#Added the Qtip public to run the Qtip test after install on bare metal nodes.
#maas $PROFILE sshkeys new key="`cat ./maas/sshkeys/QtipKey.pub`"
@@ -500,6 +551,7 @@ addcloud() {
echo " auth-types: [oauth1]" >> maas-cloud.yaml
echo " endpoint: $API_SERVERMAAS" >> maas-cloud.yaml
+ echo_info "Adding cloud $cloudname"
juju add-cloud $cloudname maas-cloud.yaml --replace
}
@@ -517,7 +569,7 @@ if [ -e ./labconfig.json ]; then
# Get the NAME/SYS_ID of this node
NODE_NAME=$(cat labconfig.json | jq --raw-output ".lab.racks[0].nodes[$NODE_ID].name")
NODE_SYS_ID=$(maas $PROFILE nodes read | jq -r ".[] | select(.hostname==\"$NODE_NAME\")".system_id)
- echo ">>> Configuring node $NODE_NAME [$NODE_ID][$NODE_SYS_ID]"
+ echo_info ">>> Configuring node $NODE_NAME [$NODE_ID][$NODE_SYS_ID]"
# Recover the network interfaces list and configure each one
# with sorting the list, we have hardware interface first, than the vlan interfaces
IF_LIST=$(cat labconfig.json | jq --raw-output ".lab.racks[0].nodes[$NODE_ID].nics[] ".ifname | sort -u )
@@ -530,9 +582,9 @@ if [ -e ./labconfig.json ]; then
'public') IF_MODE='AUTO' ;;
'storage') IF_MODE='AUTO' ;;
'floating') IF_MODE='link_up' ;;
- *) SUBNET_CIDR='null'; IF_MODE='null'; echo " >>> Unknown SPACE" ;;
+ *) SUBNET_CIDR='null'; IF_MODE='null'; echo_info " >>> Unknown SPACE" ;;
esac
- echo " >>> Configuring interface $IF_NAME [$IF_SPACE][$SUBNET_CIDR]"
+ echo_info " >>> Configuring interface $IF_NAME [$IF_SPACE][$SUBNET_CIDR]"
# if we have a vlan parameter in the space config
IF_VLAN=$(cat labconfig.json | jq --raw-output ".opnfv.spaces[] | select(.type==\"$IF_SPACE\")".vlan)
@@ -545,7 +597,7 @@ if [ -e ./labconfig.json ]; then
# In case of a VLAN interface
if ([ $IF_VLAN ] && [ "$IF_VLAN" != "null" ]); then
- echo " >>> Configuring VLAN $IF_VLAN"
+ echo_info " >>> Configuring VLAN $IF_VLAN"
VLANID=$(maas $PROFILE subnets read | jq ".[].vlan | select(.vid==$IF_VLAN)".id)
FABRICID=$(maas $PROFILE subnets read | jq ".[].vlan | select(.vid==$IF_VLAN)".fabric_id)
INTERFACE=$(maas $PROFILE interfaces read $NODE_SYS_ID | jq ".[] | select(.vlan.fabric_id==$FABRICID)".id)
@@ -584,7 +636,7 @@ if [ -e ./labconfig.json ]; then
maas $PROFILE interface link-subnet $NODE_SYS_ID $IF_NAME mode=$IF_MODE subnet=$SUBNET_CIDR || true
sleep 2
else
- echo " >>> Not configuring, we have an empty Subnet CIDR"
+ echo_info " >>> Not configuring, we have an empty Subnet CIDR"
fi
done
@@ -602,4 +654,4 @@ fi
#
# End of scripts
#
-echo " .... MAAS deployment finished successfully ...."
+echo_info " .... MAAS deployment finished successfully ...."